\ KnitBotF.fth for tTaqoz
\ CWE 28.10.24

{
   A: Tests
   B: mit Beschleunigung
   C: 4 Achsen
   D: Linear Interpolation
   E: gekuertzt
   F: schneller
}

IFDEF *KnitBot*
    \ 6 cogstop
    oldorg org
    FORGET *KnitBot*  }


pub *KnitBot*    PRINT" KnitBotF.fth" ;

0 bytes oldorg

!polls \ clear multitasking

\ 7 cogstop \ stop video


--- { Pins, Variables

--- VGA: 2nd header 8-15

\ GND verbunden, 3V3 verbunden, 12V am Eingang fr S-Motor Platine
\ alle M open: Microstep8

16 := enablePin    \
\                      X, Y, Z, Rotation
0 cells table dirPins  17 , 19 , 21 , 23 ,
0 cells table stepPins 18 , 20 , 22 , 24 ,

57 := dLedPin

18_000 value stepTime# \ tover: 18000 Mechanik: 12_000
400 8 * 100 * value accel#
1000 value minDist#
long stepFlag
long overFlag

0 value mxTr# \ maximum travel of this movement
0 value mxDir# \ axis with the maximum travel = leading

\ tables with values for each axis
0 cells table actPos 0 , 0 , 0 , 0 ,
4 cells table startPos
4 cells table destPos
4 cells table traveled
4 cells table remain
0 cells table destStepT 0 , 0 , 0 , 0 , \ for linear movement
0 cells table actStepT 0 , 0 , 0 , 0 , \ for linear movement with acceleration and decceleration
4 cells table oldCnt

\ } Pins and Variables

: mechanics_Library ; \ { Blinker Heartbeat Stepper Servo ##############

dLedPin blink   1 hz

enablePin high

\ enableABPin low dirAPin low stepAPin blink 100 hz \ test stepper A
\ stepAPin float \ stop

: zSet \ set all axis zero
   4 for
       0 actPos I cells + !
   next
;

: stepOff ( -- ) enablePin high ;

: stepOn ( -- ) enablePin low ;

: setPolarityI \ at pins index longs. in I !
   destPos I+ @   actPos I+ @ > if
      dirPins I+ @ low
   else
      dirPins I+ @ high
   then
;

: stepDirI \ do a step in direction I index for longs.
   remain I+ @ 0exit
   stepFlag ~~
   stepPins I+ @  pin t \ toggle
   traveled I+ ++
   remain I+ --
   \ cnt@ oldCnt I+ !
   actStepT i+ @  oldCnt I+ +!
   \ cnt@ oldCnt I+ @ -   actStepT i+ @ > if overFlag ++ then
;

: getMxDir {: , tr# -- }  \ get the number of the axis with maximum travel mxTr# into mxDir#
   0 to mxTr#
   0 to mxDir#
   0 16 ado
      destPos i+ @   startPos i+ @ - ABS to_tr# \ travel of this direction
      tr# remain i+ !
      tr# mxTr# > if tr# to mxTr#   i 4/ to mxDir# then
      traveled i+ ~
   4 +loop
; forgetLocals

: calcLinTimes \ calculate destStepT for linear movement , no acceleration
   4 for
      stepTime# mxTr#
      destPos i cells + @   startPos i cells + @ - ABS  1 maxs
      */
      destStepT i cells + ! \ store step Time
   next
;

: calcTimes {: , timeFactor# } \ with accel deccel for all axis
   accel#
   traveled mxDir# cells + @
   remain mxDir# cells + @ mins
   minDist# +
   / 100 maxs \ not faster than 100 percent
   to_timeFactor#
   0 16 ado
      timeFactor#
      destStepT i+ @   100 */   actStepT i+ !
   4 +loop
; forgetLocals

: addDist ( -- distanceAbs ) \ add up all distances abs
   0
   remain 16 ado
      I @ +
   4 +loop
;

: goLinear \ go to new linear destiny position

   0 16 ado
      actPos i+ @   startPos i+ !
      setPolarityI
   4 +loop
   getMxDir \ sets traveled, remain,
   addDist 0exit
   calcLinTimes
   calcTimes
   stepFlag ~

   cnt@ oldCnt !   cnt@ oldCnt 4 + !   cnt@ oldCnt 8 + !   cnt@ oldCnt 12 + !

   begin
   addDist while
      stepFlag @ if
         calcTimes
         stepFlag ~
      then
      0 16 ado
         cnt@ oldCnt i+ @ -   actStepT i+ @ > if
            stepDirI \ with index !
         then
      4 +loop
   repeat
;



: wOn ( -- ) stepOn 10 ms ;
: wOff ( -- ) 200 ms stepOff ;

: go4D {: x# y# z# rot# -- } \ go linear to new position
   x# destPos 0 cells + !
   y# destPos 1 cells + !
   z# destPos 2 cells + !
   rot# destPos 3 cells + !
   wOn goLinear wOff
   0 16 ado
      destPos i+ @   actPos i+ !
   4 +loop
; forgetLocals

: gtDir {: dest# dir# -- } \ go one axis to new position
   dest# destPos dir# cells + !
   wOn goLinear wOff
   0 16 ado
      destPos i+ @   actPos i+ !
   4 +loop
; forgetLocals

: info. \ print position information
   crlf
   ." start, act, dest, tr, rem, destStepTime actStepT"
      0 16 ado
         crlf
         startPos i+ @ .
         actPos i+ @ .
         destPos i+ @ .
         traveled i+ @ .
         remain i+ @ .
         destStepT i+ @ .
         actStepT i+ @ .
      4 +loop
;

400 8 * value jogStep#

: jog {: , k# } \
   wOn
   ." +/- step, 4/6 X, 2/8 Y, 3/9 Z, 1/7 Rot, Zero, Esc"
   key drop
   begin
      crlf ." Step: " jogStep# . ." XYZA: "
      4 for
         actPos i cells + @ .
      next
      wkey to_k#
   k# 27 <> while
      '+' k# = if jogStep# 10 * to jogStep# then
      '-' k# = if jogStep# 10 / 8 maxs to jogStep# then
      '4' k# = if actPos @ jogStep# - 0 gtDir then
      '6' k# = if actPos @ jogStep# + 0 gtDir then
      '2' k# = if actPos 4 + @ jogStep# - 1 gtDir then
      '8' k# = if actPos 4 + @ jogStep# + 1 gtDir then
      '3' k# = if actPos 8 + @ jogStep# - 2 gtDir then
      '9' k# = if actPos 8 + @ jogStep# + 2 gtDir then
      '1' k# = if actPos 12 + @ jogStep# - 3 gtDir then
      '7' k# = if actPos 12 + @ jogStep# + 3 gtDir then
      'z' k# = if zSet then
   repeat
   wOff
; forgetLocals


: t1 10000 20000 0 0 go4D ;
: t2 -10000 -20000 0 0 go4D ;
: t3 0 0 0 0 go4D ;
: t4 -10000 -20000 15000 6400 go4D ;

{
: tover
   overFlag ~
   t4 t3 overFlag @ .
;
}

\ } mechanics_Library
